// VERSION 5.0
// added output to log to find LEVEL BUG (comes from Handicap mode)!!
// removed some unneccesary handle closes on map end
// added config files for WIN and JOIN Sounds
// added sound files for Hunter & Terminator
//
// VERSION 5.1
// added chicken model(not activated)
// add cvar for terminator health
//
// VERSION 5.2
// added Timer_flag_no_mapchange
// added another weapon bug check event player spawn
//
// VERSION 5.2light
// removed : sm_gungame_enabled
// removed : sm_gungame_lastlevelcenterinfo
// removed : sm_gungame_nadelasereffect
// removed : sm_gungame_bazooka_shake_effect, sm_gungame_bazooka_shake_effect_amp, sm_gungame_bazooka_shake_effect_dur
// removed : sm_gungame_spawnprotect, sm_gungame_spawnprotect_time, sm_gungame_spawnprotect_message
// removed : sm_gungame_roundendspeed (controlled now with sm_gungame_meleespeed)
// error on weapon bug3: it seems player got always spade. now i set them 1 level lower!!
// fixed line ~272: added && IsPlayerAlive
//
// VERSION 5.3light
// removed : sm_gungame_bonustimekill (no need of sdkhooks now!!)
// changed g_iOffset to CDODPlayer in pluginstart.sp
//
// VERSION 5.4light
// removed chicken model. found nothing to do with it :)
// removed sm_gungame_health_on_levelup (its now controlled with sm_gungame_health_on_levelup if its greather then >= 1)
// add "&& (iLevel >=1))" at line ~732
//
// VERSION 5.5light
// changed random player class to rifleman (did not spam chat now !!)
//
// VERSION 5.6light
// added checks for fakeclient, some fixes
//
// VERSION 5.7light
// added permanent run when switch to spade! new cvar: sm_gungame_spadespeed
// 
// VERSION 5.8light
// removed dodhooks
//
// VERSION 5.9
// Bots cannot be Hunter & Terminator
// added some client&weapon checks
//
// VERSION 6.0
// changed getclientauthstring (845)
//

#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#define PLUGIN_VERSION "6.0light"
static const String:g_szObjectives[][] = {"dod_bomb_target","dod_capture_area"};
static const String:g_szTeamWalls[][] = {"func_team_wall","func_teamblocker"};

public Plugin:myinfo =
{
	name        = "DoD:S GunGame",
	author      = "Darkranger (orig. by Tsunami), with help from friends of dodsplugins.com",
	description = "DoD:S GunGame for SourceMod",
	version     = PLUGIN_VERSION,
	url         = "http://dark.asmodis.at"
}

#include "gungame6.0light\overlay_strings.sp"
#include "gungame6.0light\database.sp"
#include "gungame6.0light\init.sp"
#include "gungame6.0light\mapstart.sp"
#include "gungame6.0light\laser_aim.sp"
#include "gungame6.0light\pluginstart.sp"
#include "gungame6.0light\eventshutdown.sp"
#include "gungame6.0light\loadconfig.sp"
#include "gungame6.0light\mapend.sp"
#include "gungame6.0light\overlay_function.sp"
#include "gungame6.0light\no_weapon_check.sp"
#include "gungame6.0light\hunter_terminator.sp"
#include "gungame6.0light\win_join_sounds.sp"
#include "gungame6.0light\runcommand.sp"

public OnClientPutInServer(client)
{
	CreateTimer(10.0, Announcegghelp, client, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(15.0, Announceggtop10, client, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(30.0, Announcegghelp, client, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(35.0, Announceggtop10, client, TIMER_FLAG_NO_MAPCHANGE);
	g_iLevel[client] = 1;
	g_iOldLevel[client] = 1;
	if(GetConVarInt(g_gungame_winjoinsound) == 1 || 3)
	{
		CreateTimer(1.0, Play_Join_Sound, client, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public OnClientPostAdminCheck(client)
{
	IsProtected[client] = false;
	if (g_bEnabled && g_ggWinner == -1 && !StrEqual(g_sSoundJoin, ""))
	{
		EmitSoundToClient(client, g_sSoundJoin);
	}
	new iClients  = GetTeamClientCount(2) + GetTeamClientCount(3), iLevel = 0;
	if (GetConVarBool(g_hHandicap) && iClients > 0)
	{
		for (new i  = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && GetClientTeam(i) > 1)
			{
				iLevel += GetLevel(i);
				//LogMessage("GG Handicap - PostAdminCheck - Count Players - %N - Level: %d ", i, GetLevel(i));
			}
		}
		g_iLevel[client] = iLevel / iClients;
		//LogMessage("GG Handicap - PostAdminCheck - New player %N - average Level: %d ", client, g_iLevel[client]);
	}
	else
	{
		g_iLevel[client] = 1;
	}
	g_iWeapon[client]  = -1;
}

public Action:Announcegghelp(Handle:timer, any:client)
{
	if((IsClientInGame(client)) && (!IsFakeClient(client)))
	PrintToChat(client, "%s\x07FFFF00%t", g_sPrefix, "gg help");
	return Plugin_Handled;
}

public Action:Announceggtop10(Handle:timer, any:client)
{
	if (GetConVarFloat(g_database_winner) == 1)
	{
		if((IsClientInGame(client)) && (!IsFakeClient(client)))
		PrintToChat(client, "%s\x07FFFF00%t", g_sPrefix, "gg top10");
	}
	return Plugin_Handled;
}

public OnRoundStart()
{
	RemoveFlagSound();
}

public OnConfigsExecuted()
{
	LoadConfig2();
}

public OnClientDisconnect(client)
{

}

public OnGameFrame()
{
	if (g_bEnabled && g_ggWinner == -1)
	{
		// LASER AIM
		if((terminator_laser_aim == 1) && (GetConVarInt(g_terminatorlaseraimcvar) == 1))
		{
			if (IsClientInGame(terminator))
			{
				CreateBeam(terminator);
			}
		}
		for (new i    = 1, iAmmo, iAmount; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsPlayerAlive(i) && !StrEqual(g_sWeapon[g_iLevel[i]], "frag_ger") && !StrEqual(g_sWeapon[g_iLevel[i]], "frag_us"))
			{
				if(!StrEqual(g_sWeapon[g_iLevel[i]], "spade") && !StrEqual(g_sWeapon[g_iLevel[i]], "amerknife"))
				{
					iAmmo     = g_iAmmo[GetLevel(i)], iAmount = g_iAmount[i];
					if (iAmmo > g_iOffset && GetEntData(i, iAmmo) <= iAmount)
					{
						SetEntData(i, iAmmo, iAmount * 2, _, true);
					}
				}
				else
				{
					if ((g_bDoubleJump) && IsClientInGame(i) && IsPlayerAlive(i) && !IsFakeClient(i))
					{
						DoubleJump(i);
					}
				}
			}
		}
	}
	// BONUSROUND
	if (g_ggWinner != -1)
	{
		for(new client = 1; client <= MaxClients; client++)
		{
			if(IsClientInGame(client) && IsPlayerAlive(client))
			{
//				SetEntPropFloat(client, Prop_Send, "m_flStamina", 80.0);
//				SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", GetConVarFloat(g_runspeed));
				if ((g_bDoubleJump) && IsClientInGame(client) && IsPlayerAlive(client) && !IsFakeClient(client))
					{
						DoubleJump(client);
					}
			}
			if((GetConVarInt(g_SpecLockGG) == 1) && IsClientInGame(client))
			{
				new team = GetClientTeam(client);
				if(team == 1) //1=SPEC 2=US 3=WEHRMACHT
				{
					EmitSoundToClient(client, "common/weapon_denyselect.wav");
					PrintCenterText(client, "SPECTATOR IS LOCKED");
					PrintToChat(client, "SPECTATOR IS LOCKED");
					new team1;
					new team2;
					for (new i = 1; i < GetMaxClients(); i++)
					{
						if(IsClientInGame(i))
						{
							if(GetClientTeam(i) == 2)
							team1++;
							else if(GetClientTeam(i) == 3)
							team2++;
						}
					}
					if (team1 <= team2)
					{
						FakeClientCommandEx(client, "jointeam 2");
						CreateTimer(0.2, randomjoinclass, client, TIMER_FLAG_NO_MAPCHANGE);
					}
					if (team2 < team1)
					{
						FakeClientCommandEx(client, "jointeam 3");
						CreateTimer(0.2, randomjoinclass, client, TIMER_FLAG_NO_MAPCHANGE);
					}
				}
			}
		}
	}
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bEnabled)
	{
		// SUPERMANN
		if((GetConVarInt(g_superman) == 1) && (g_ggWinner != -1))
		{
			superman = g_ggWinner;
			if(IsClientInGame(superman))
			{
				SetEntityModel(superman , SUPERMAN_MDL);
			}
		}
		new iClient = GetClientOfUserId(GetEventInt(event, "userid"));
		if (GetClientTeam(iClient) > 1)
		{
			if (IsValidClient(iClient))
			{
				CreateTimer(1.5, NoWeaponCheck, iClient, TIMER_FLAG_NO_MAPCHANGE);
			}	
			if ((GetConVarInt(g_gungame_custom_on) == 1) && IsClientConnected(iClient))
			{
				decl String:customtext1[256];
				GetConVarString(g_gungame_customtext1, customtext1, sizeof(customtext1));
				PrintCenterText(iClient, "%s", customtext1);
				PrintToChat(iClient, "%s >> %s", g_sPrefix, customtext1);
			}
			if ((GetConVarInt(g_gungame_custom_on) == 2) && IsClientConnected(iClient))
			{
				decl String:customtext2[256];
				GetConVarString(g_gungame_customtext2, customtext2, sizeof(customtext2));
				PrintCenterText(iClient, "%s", customtext2);
				PrintToChat(iClient, "%s >> %s", g_sPrefix, customtext2);
			}
			GetClientAbsOrigin(iClient, g_fPosition[iClient]);
			for (new i = 0, s; i < 5; i++)
			{
				if ((s = GetPlayerWeaponSlot(iClient, i)) != -1)
				{
					RemoveWeapon(iClient, s);
				}
			}
			if(g_ggWinner != -1)
			{
				GivePlayerItem(iClient, "weapon_spade");
				return;
			}
			new iLevel        = g_iLevel[iClient];
			g_iWeapon[iClient] = -1;
			PrintToChat(iClient, "%s%t", g_sPrefix, "Level", 4, iLevel, 1, 4, g_sWeapon[iLevel]);
			if((IsClientInGame(iClient)) && (IsPlayerAlive(iClient)))
			{
				GiveWeapon(iClient); // ERROR WEAPON BUG
			}
			if (!StrEqual(g_sWeapon[iLevel], "amerknife") && !StrEqual(g_sWeapon[iLevel], "spade") && (IsClientInGame(iClient)))
			{
				GivePlayerItem(iClient, "weapon_spade");
			}
			if (IsValidClient(iClient))
			{
				CreateTimer(0.3, NoWeaponCheck, iClient, TIMER_FLAG_NO_MAPCHANGE);
			}	
		}
	}
}

public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bEnabled && g_ggWinner == -1)
	{
		decl Float:fPosition[3], String:sWeapon[16];
		new iAttackerID = GetEventInt(event, "attacker"),
				iClientID   = GetEventInt(event, "userid"),
				iAttacker   = GetClientOfUserId(iAttackerID),
				iClient     = GetClientOfUserId(iClientID);
		GetClientAbsOrigin(iClient, fPosition);
		GetEventString(event, "weapon", sWeapon, sizeof(sWeapon));
		if(iClientID == iAttackerID || iAttackerID == 0)
		{
			CreateTimer(0.2, g_OverlaySuicide, iClient, TIMER_FLAG_NO_MAPCHANGE);
		}
		if (IsValidEntity(g_iWeapon[iClient]))
		{
			RemoveWeapon(iClient, g_iWeapon[iClient]);
		}
		// LASER AIM
		if ((terminator_laser_aim == 1) && (terminator == iClient))
		{
			 terminator_laser_aim = 0;
		}
		if (iAttacker == 0 || iAttacker == iClient)
		{
			if ((g_iLevel[iClient] > 1) && !IsFakeClient(iClient))
			{
				g_iLevel[iClient]--;
				PrintToChatAll("%s%t", g_sPrefix, "Suicide", 4, iClient, 1);
				CreateTimer(0.2, g_OverlaySuicide, iClient, TIMER_FLAG_NO_MAPCHANGE);
				LogEvent("gg_leveldown",    iClientID);
				if (!StrEqual(g_sSoundLevelDown,    ""))
				{
					EmitSoundToClient(iClient, g_sSoundLevelDown);
				}
			}
		}
		else if	((GetClientTeam(iAttacker) == GetClientTeam(iClient)) && (GetConVarInt(g_gungame_punishment) == 1))
		{
			if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker))
			{
				if ((g_iLevel[iAttacker] > 1) && !IsFakeClient(iAttacker))
				{
					g_iLevel[iAttacker]--;
					PrintToChatAll("%s%t", g_sPrefix, "Team Kill", 4, iAttacker, 1);
					LogEvent("gg_leveldown", iAttackerID);
					if (!StrEqual(g_sSoundLevelDown,    ""))
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelDown);
					}
					CreateTimer(0.2, Timer_Give, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
					CreateTimer(0.2, g_OverlayTeamKillLevelLost, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
				}
			}
		}
		else if ((GetClientTeam(iAttacker) == GetClientTeam(iClient)) && (GetConVarInt(g_gungame_punishment) == 2 || (GetConVarInt(g_gungame_punishment) == 4)))
		{
			if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker) && !IsFakeClient(iAttacker))
			{
				CreateTimer(0.1, Spade_Loss, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
				CreateTimer(0.2, g_OverlayTeamkill_Spade, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
		else if ((GetClientTeam(iAttacker) == GetClientTeam(iClient)) && (GetConVarInt(g_gungame_punishment) == 3 || (GetConVarInt(g_gungame_punishment) == 5)))
		{
			if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker) && !IsFakeClient(iAttacker))
			{
				g_iLevel[iAttacker]--;
				PrintToChatAll("%s%t", g_sPrefix, "Team Kill", 4, iAttacker, 1);
				LogEvent("gg_leveldown", iAttackerID);
				if (!StrEqual(g_sSoundLevelDown,    ""))
				{
					EmitSoundToClient(iAttacker, g_sSoundLevelDown);
				}
				CreateTimer(0.2, Spade_Loss, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
				CreateTimer(0.2, g_OverlayLevelLostSpade, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
		else if (GetClientTeam(iAttacker) != GetClientTeam(iClient) && (StrEqual(sWeapon, g_sWeapon[GetLevel(iAttacker)]) || StrEqual(sWeapon, "spade")))
		{
			if (fPosition[0] == g_fPosition[iClient][0] && fPosition[1] == g_fPosition[iClient][1])
			{
				PrintHintText(iAttacker, "%t", "AFK", iClient);
			}
			else if (g_iLevel[iAttacker]++ < g_iLevels)
			{
				if (StrEqual(sWeapon, "spade") && g_iLevel[iClient] > 1)
				{
					g_iLevel[iClient]--;
					PrintToChatAll("%s%t", g_sPrefix, "Steal", 4, iAttacker, 1, 4, iClient, 1);
					LogEvent("gg_levelsteal", iAttackerID);
					LogEvent("gg_leveldown",  iClientID);
					CreateTimer(0.2, g_OverlayLevel_Steal, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
					if (!StrEqual(g_sSoundLevelSteal, ""))
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelSteal);
					}
					if (!StrEqual(g_sSoundLevelDown,  ""))
					{
						EmitSoundToClient(iClient,   g_sSoundLevelDown);
					}
					// SOUND LAST LEVEL
					if (g_iLevel[iAttacker] == g_iLevels)
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelLast);
						PrintToChatAll("%s \x06%N \x04%t", g_sPrefix, iAttacker, "lastlevel");
						PrintHintTextToAll("%N %t", iAttacker, "lastlevel");
					}
				}
				else
				{
					// 4.7 GIVE HEALTH TO ATTACKER
					if(GetConVarInt(g_healthONlevelupvar) >= 1)
					{
						new healthvar;
						new currentHealth;
						healthvar = (100 - GetConVarInt(g_healthONlevelupvar));
						currentHealth = GetEntProp(iAttacker, Prop_Send, "m_iHealth");
						if (currentHealth <= healthvar)
						{
							SetEntProp(iAttacker, Prop_Send, "m_iHealth", currentHealth + GetConVarInt(g_healthONlevelupvar));
						}
					}
					LogEvent("gg_levelup",    iAttackerID);
					CreateTimer(0.2, g_OverlayLevel_Up, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
					if (!StrEqual(g_sSoundLevelUp,    ""))
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelUp);
					}
					// SOUND LAST LEVEL
					if (g_iLevel[iAttacker] == g_iLevels)
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelLast);
						PrintToChatAll("%s \x06%N \x04%t", g_sPrefix, iAttacker, "lastlevel");
						PrintHintTextToAll("\n %N %t \n", iAttacker, "lastlevel");
					}
					// VOTE x LEVELS BEFORE LAST LEVEL
					if ((g_iLevel[iAttacker] == (g_iLevels - ((GetConVarInt(g_votebeforeendlevel) -1)))) && (votebeforeendvar == 0) && (GetConVarFloat(g_votebeforeend) == 1))
					{
						// NEW VOTE
						decl String:Runvote[256];
						GetConVarString(g_runvote, Runvote, sizeof(Runvote));
						ServerCommand("%s", Runvote);
						votebeforeendvar = 2;
						if (GetConVarFloat(g_votesoundfile) == 1)
						{
							EmitSoundToAll(g_sSoundvote);
						}
					}
				}
				// HUNTER
				if(GetConVarInt(g_hunter) == 1)
				{
					if (((g_iLevel[iAttacker]) == huntertime1) && (huntcount1 < 2))
					{
						CreateTimer(GetRandomFloat(10.0, 30.0), Hunter, TIMER_FLAG_NO_MAPCHANGE);
						//LogMessage("GG Hunter - RandomCheck 1 started. Player %N triggered random with Level: %d ", iAttacker, g_iLevel[iAttacker]);
						huntcount1 = 2;
					}
					if (((g_iLevel[iAttacker]) == huntertime2) && (huntcount2 < 2))
					{
						CreateTimer(GetRandomFloat(20.0, 40.0), Hunter, TIMER_FLAG_NO_MAPCHANGE);
						//LogMessage("GG Hunter - RandomCheck 2 started. Player %N triggered random with Level: %d ", iAttacker, g_iLevel[iAttacker]);
						huntcount2 = 2;
					}
				}
				//TERMINATOR
				if(GetConVarInt(g_terminator) == 1)
				{
					if (((g_iLevel[iAttacker]) == terminatortime) && (terminatorcount < 2))
					{
						CreateTimer(GetRandomFloat(10.0, 40.0), Terminator, TIMER_FLAG_NO_MAPCHANGE);
						//LogMessage("GG Terminator - RandomCheck started  Player %N triggered random with Level: %d ", iAttacker, g_iLevel[iAttacker]);
						terminatorcount = 2;
					}
				}
				// LASER AIM
				if ((terminator_laser_aim == 1) && (terminator == iClient))
				{
				 terminator_laser_aim = 0;
				}
				new iLeader  = GetLeader(), iLevel = g_iLevel[iAttacker];
				if (IsPlayerAlive(iAttacker))
				{
					PrintToChat(iAttacker,   "%s%t", g_sPrefix, "Weapon",     4, g_sWeapon[iLevel]);
				}
				if (iLeader == iAttacker)
				{
					PrintToChatAll("%s%t", g_sPrefix, "Leader", 4, iAttacker, 1, 4, iLevel, 1);
				}
				else
				{
				new iLead  = g_iLevel[iLeader] - iLevel;
				if (iLead  > 0)
					{
					PrintToChat(iAttacker, "%s%t", g_sPrefix, "Difference", 4, iLead, 1, iLead == 1 ? "" : "s");
					}
				}
				CreateTimer(0.2, Timer_Give, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
			}
			else
			{
			 	if(g_ggWinner == -1)
				{
					g_ggWinner = iAttacker;
					// CALL SUPERMAN
					if(GetConVarInt(g_superman) == 1)
					{
						superman = iAttacker;
						SetEntityModel(superman , SUPERMAN_MDL);
					}
					if (GetConVarFloat(g_runvoteenable) == 0)
					{
						decl String:sNextMap[32];
						GetConVarString(g_hNextMap, sNextMap, sizeof(sNextMap));
						PrintToChatAll("%s%t", g_sPrefix, "Win", 4, iAttacker, 1, 4, sNextMap);
					}
					Play_Win_Sound();

					// DATABASE
					if (GetConVarFloat(g_database_winner) == 1)
					{
						new ggWinner = iAttacker;
						UpdateWinner(ggWinner);
					}
					if (GetConVarFloat(g_overlaytyp) == 1)
					{
						g_RoundEndOverlayBW();
					}
					if (GetConVarFloat(g_overlaytyp) == 2)
					{
						g_RoundEndOverlay();
					}
					if (!IsFakeClient(iAttacker))
					{
						Show_ggWinner(iAttacker);
					}
					LogEvent("gg_win", iAttackerID);
					if (FindPluginByFile("dods_bots.smx") != INVALID_HANDLE)
					{
						ServerCommand("sm plugins unload dods_bots.smx");
					}
					if (GetConVarFloat(g_runvoteenable) == 1)
					{
						CreateTimer(GetConVarFloat(g_bonustimevote), Timer_EndGame, TIMER_FLAG_NO_MAPCHANGE);
						if (GetConVarFloat(g_votesoundfile) == 1)
						{
							EmitSoundToAll(g_sSoundvote);
						}
					}
					if (GetConVarFloat(g_runvoteenable) == 0)
					{
						CreateTimer(GetConVarFloat(g_bonustime), Timer_EndGame, TIMER_FLAG_NO_MAPCHANGE);
					}
					if (!StrEqual(g_sSoundWin, ""))
					{
						EmitSoundToAll(g_sSoundWin);
					}
					decl String:Runcommand[256];
					GetConVarString(g_runcommand, Runcommand, sizeof(Runcommand));
					ServerCommand("%s", Runcommand);
					if (GetConVarFloat(g_runvoteenable) == 1)
					{
						CreateTimer(10.0, Timer_MapVote, TIMER_FLAG_NO_MAPCHANGE);
					}
					// REMOVE CLIENT WEAPONS
					for(new client = 1; client <= MaxClients; client++)
					{
						if(IsClientInGame(client) && IsPlayerAlive(client) && !IsFakeClient(client))
						{
						for (new i = 0, s; i < 5; i++)
							{
								if ((s = GetPlayerWeaponSlot(client, i)) != -1)
								{
									RemoveWeapon(client, s);
								}
							}
						GivePlayerItem(client, "weapon_spade");
						}
						if(IsClientInGame(client) && IsPlayerAlive(client) && IsFakeClient(client))
 						{
							KickClient(client);
							//LogMessage("BOT %N kicked GAME", client);
						}
					}
					// KICK BOTS FROM SPEC
					for(new client = 1; client <= MaxClients; client++)
					{
						if(IsClientInGame(client) && IsFakeClient(client))
						{
							KickClient(client);
							//LogMessage("BOT %N kicked SPEC", client);
						}
					}
				}
			}
		}
	}
}

public Action:Command_Drop(client, args)
{
	return g_bEnabled ? Plugin_Handled : Plugin_Continue;
}


public Action:Timer_MapVote(Handle:timer)
{
	decl String:Runvote[256];
	GetConVarString(g_runvote, Runvote, sizeof(Runvote));
	ServerCommand("%s", Runvote);
}

public Action:Show_ggWinner(ggWinner)
{
	new Handle:ggWinnerMenu = INVALID_HANDLE;
	ggWinnerMenu = CreatePanel();
	decl String:menutitle[256];
	Format(menutitle, sizeof(menutitle), "DoD GunGame");
	SetPanelTitle(ggWinnerMenu, menutitle);
	DrawPanelItem(ggWinnerMenu, "", ITEMDRAW_SPACER);
	decl String:Winner[256];
	Format(Winner, sizeof(Winner), "%t %N", "win1phrase", ggWinner);
	DrawPanelText(ggWinnerMenu, Winner);
	DrawPanelItem(ggWinnerMenu, "", ITEMDRAW_SPACER);
	if (GetConVarFloat(g_runvoteenable) == 0)
	{
		decl String:sNextMap[32];
		GetConVarString(g_hNextMap, sNextMap, sizeof(sNextMap));
		decl String:NextMap[256];
		Format(NextMap, sizeof(NextMap), "%t %s", "win2phrase", sNextMap);
		DrawPanelText(ggWinnerMenu, NextMap);
		DrawPanelItem(ggWinnerMenu, "", ITEMDRAW_SPACER);
	}
	SetPanelCurrentKey(ggWinnerMenu, 10);
	DrawPanelItem(ggWinnerMenu, "Close", ITEMDRAW_CONTROL);
	for(new i = 1; i <= MaxClients; i++)
	{
		if(IsClientConnected(i) && IsClientInGame(i) && !IsFakeClient(i))
		{
			SendPanelToClient(ggWinnerMenu, i, Handle_ggWinnerMenu, 14);
		}
	}
	if((GetConVarInt(g_TeamWallRemoveGameEnd) == 1) && (GetConVarInt(g_TeamWallRemoveGame) == 0))
	{
		new entity = -1;
		for (new i = 0; i < sizeof(g_szTeamWalls); i++)
		{
		while ((entity = FindEntityByClassname(entity, g_szTeamWalls[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Handle_ggWinnerMenu(Handle:TeamStatsMenu, MenuAction:action, client, itemNum)
{
}


public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	new entity = -1;
	if (GetConVarInt(g_CPdisable) == 1)
	{
		for (new i = 0; i < sizeof(g_szObjectives); i++)
		{
			while ((entity = FindEntityByClassname(entity, g_szObjectives[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
		entity = -1;
		while ((entity = FindEntityByClassname(entity, "dod_control_point")) != -1)
		{
			AcceptEntityInput(entity, "HideModel");
		}
	}
	if (GetConVarInt(g_TeamWallRemoveGame) == 1)
	{
		entity = -1;
		for (new i = 0; i < sizeof(g_szTeamWalls); i++)
		{
			while ((entity = FindEntityByClassname(entity, g_szTeamWalls[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Action:Timer_EndGame(Handle:timer)
{
	new iGameEnd  = FindEntityByClassname(-1, "game_end");
	if (iGameEnd == -1 && (iGameEnd = CreateEntityByName("game_end")) == -1)
	{
		LogError("Unable to create entity \"game_end\"!");
	}
	else
	{
		for (new i = 1; i < GetMaxClients(); i++)
		{
			if(IsClientInGame(i))
			{
				g_iLevel[i] = 1;
				if (IsValidEntity(g_iWeapon[i]))
				{
					g_iWeapon[i]  = -1;
				}
				//LogMessage("GG Reset Client - %N", i);
			}
		}
		AcceptEntityInput(iGameEnd, "EndGame");
	}
}

public Action:Timer_Give(Handle:timer,  any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		GiveWeapon(client);
	}
}

public Action:Spade_Loss(Handle:timer,  any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		for (new i = 0, s; i < 5; i++)
		{
			if ((s = GetPlayerWeaponSlot(client, i)) != -1)
			{
				RemoveWeapon(client, s);
			}
		}
		PrintToChatAll("%s \x06%N \x04%t", g_sPrefix, client, "Team Kill Spade");
		GivePlayerItem(client, "weapon_spade");
		if ((GetConVarInt(g_gungame_punishment) == 4) || (GetConVarInt(g_gungame_punishment) == 5))
		{
			SetEntityHealth(client, GetConVarInt(g_spadeknifehealth));
		}
	}
}

GiveWeapon(iClient)
{
	decl iWeapon, String:sWeapon[24];
	new iLevel = g_iOldLevel[iClient] = g_iLevel[iClient];
	Format(sWeapon, sizeof(sWeapon), "weapon_%s", g_sWeapon[iLevel]);
	if ((IsValidEntity(g_iWeapon[iClient])) && (iLevel >=1))
	{
		RemoveWeapon(iClient, g_iWeapon[iClient]);
	}
	else
	{
		if (iLevel <1)
		{
			NoWeaponCheck_remove2(iClient);
		}
	}
	iWeapon = GetPlayerWeaponSlot(iClient, 2);
	if (iWeapon != -1 && (iLevel >=1) && StrEqual(g_sWeapon[iLevel], "amerknife") || StrEqual(g_sWeapon[iLevel], "spade"))
	{
		RemoveWeapon(iClient, iWeapon);
	}
	g_iWeapon[iClient] = GivePlayerItem(iClient, sWeapon);
	if ((iLevel >=1) && (StrEqual(g_sWeapon[iLevel], "frag_ger") || StrEqual(g_sWeapon[iLevel], "frag_us")))
	{
		SetEntData(iClient, g_iAmmo[iLevel], GetConVarInt(g_nades), _, true);
		PrintHintText(iClient, "%t", "grenades", GetConVarInt(g_nades));
		PrintToChat(iClient, "%s%t", g_sPrefix, "grenades", GetConVarInt(g_nades));
	}
	else if(StrEqual(g_sWeapon[iLevel], "spade") || StrEqual(g_sWeapon[iLevel], "amerknife"))
	{
		SetEntityHealth(iClient, GetConVarInt(g_spadeknifehealth));
		PrintToChat(iClient, "%s%t", g_sPrefix, "spadeknifehealth2", GetConVarInt(g_spadeknifehealth));
	}
	else
	{
		if (IsValidEntity(g_iWeapon[iClient]))
		{
			if ((g_iAmount[iClient] = GetEntData(g_iWeapon[iClient], g_iClip)) < 1)
			{
				g_iAmount[iClient]    = 1;
			}
			if (g_iAmmo[iLevel]     > 0)
			{
				SetEntData(iClient, g_iAmmo[iLevel], g_iAmount[iClient] * 2, _, true);
			}
		}
		else
		{
			if (IsValidClient(iClient))
			{
				CreateTimer(0.1, NoWeaponCheck_CLIP, iClient, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
	if (IsValidClient(iClient))
	{
		CreateTimer(0.5, NoWeaponCheck_remove_giveweapon, iClient, TIMER_FLAG_NO_MAPCHANGE);
	}	
}

GetLeader()
{
	new iLeader = 0;
	for (new i  = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && g_iLevel[i] > g_iLevel[iLeader])
		{
			iLeader = i;
		}
	}
	return iLeader;
}

GetLevel(iClient)
{
	return g_iLevel[iClient];
}

LogEvent(const String:sName[], iUserID)
{
	decl String:sAuth[32];
	new iClient = GetClientOfUserId(iUserID);
	decl String:sTeam[32];
	if(GetClientTeam(iClient) == 2)
		{
		Format(sTeam, sizeof(sTeam), "Allies");
		}
		else
		{
		Format(sTeam, sizeof(sTeam), "Axis");
		}
	//GetClientAuthString(iClient, sAuth, sizeof(sAuth));
	GetClientAuthId(iClient, AuthId_Steam2, sAuth, sizeof(sAuth));
	LogToGame("\"%N<%d><%s><%s>\" triggered \"%s\"", iClient, iUserID, sAuth, sTeam, sName);
}

RemoveWeapon(iClient, iWeapon)
{
	if (IsValidClient(iClient))
	{
		CreateTimer(5.0, NoWeaponCheck_remove, iClient, TIMER_FLAG_NO_MAPCHANGE);
	}
	if (IsValidEdict(iWeapon))
	{
		RemovePlayerItem(iClient, iWeapon);
		AcceptEntityInput(iWeapon, "Kill");
	}
}

public Action:Event_PlayerTeam(Handle:event, const String:Name[], bool:DontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if((GetConVarInt(g_TeamLockGG) == 1) && (client != 0))
	{
		CreateTimer(0.1, randomjoinclassteam, client, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:randomjoinclassteam(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		FakeClientCommand(client, "cls_random");
		ShowVGUIPanel(client, "class_us", INVALID_HANDLE, false);
		ShowVGUIPanel(client, "class_ger", INVALID_HANDLE, false);
	}
}

public Action:randomjoinclass(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		FakeClientCommand(client, "cls_random");
		ShowVGUIPanel(client, "class_ger", INVALID_HANDLE, false);
		ShowVGUIPanel(client, "class_us", INVALID_HANDLE, false);
	}
}

public Event_DodStatsWeaponAttack(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(g_gungame_rapidfirepistol) == 1)
	{
		new weapon = GetEventInt(event, "weapon");
		new client = GetClientOfUserId(GetEventInt(event, "attacker"));
		new weaponindex;
		switch (weapon)
		{
			case 3, 4:
			{
				weaponindex = GetPlayerWeaponSlot(client, 1);
			}
		}
		if (weaponindex != -1)
		{
			SetEntData(weaponindex, g_offset1rapid, 1000, 4, true);
			SetEntData(weaponindex, g_offset2rapid, 2, 4, true);
		}
	}

	if (GetConVarInt(g_gungame_rapidfirebazooka) == 1)
	{
		new weapon = GetEventInt(event, "weapon");
		new client = GetClientOfUserId(GetEventInt(event, "attacker"));
		new weaponindex;
		switch (weapon)
		{
			case 17, 18:
			{
				weaponindex = GetPlayerWeaponSlot(client, 0);
			}
		}
		if (weaponindex != -1)
		{
			new Float:curTime = GetGameTime();
			SetEntData(weaponindex, g_offset1rapid, curTime + (GetConVarFloat(g_gungame_rapidfirebazdelay)), 4, true);
			SetEntData(weaponindex, g_offset2rapid, 2, 4, true);
		}
	}
}

RemoveFlagSound()
{
	if (GetConVarInt(g_CPdisable) == 1)
	{
		static soundOffset;
		new entity = -1;
		while ((entity = FindEntityByClassname(entity, "ambient_generic")) != -1)
		{
			if (!soundOffset && (soundOffset = FindDataMapOffs(entity, "m_iszSound")) == -1)
			{
				LogError("Error: Unable to find datamap offset: \"m_iszSound\"!");
				return;
			}
			decl String:sound[64];
			GetEntDataString(entity, soundOffset, sound, sizeof(sound));
			if (StrEqual(sound, FlagSnd))
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Action:HookFlagSound(String:sample[PLATFORM_MAX_PATH], &entity, &Float:volume, &level, &pitch, Float:pos[3], &flags, &Float:delay)
{
	if(StrEqual(sample, FlagSnd))
	{
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

stock DoubleJump(const any:client)
{
	new fCurFlags = GetEntityFlags(client), fCurButtons = GetClientButtons(client);
	if (g_fLastFlags[client] & FL_ONGROUND)
	{
		if (!(fCurFlags & FL_ONGROUND) && !(g_fLastButtons[client] & IN_JUMP) && fCurButtons & IN_JUMP)
		{
			OriginalJump(client);
		}
	}
	else if (fCurFlags & FL_ONGROUND)
	{
		Landed(client);
	}
	else if (!(g_fLastButtons[client] & IN_JUMP) && fCurButtons & IN_JUMP)
	{
		ReJump(client);
	}
	g_fLastFlags[client]	= fCurFlags;
	g_fLastButtons[client]	= fCurButtons;
}

stock OriginalJump(const any:client)
{
	g_iJumps[client]++;
}

stock Landed(const any:client)
{
	g_iJumps[client] = 0;
}

stock ReJump(const any:client)
{
	if ( 1 <= g_iJumps[client] <= g_iJumpMax)
	{
		g_iJumps[client]++;
		decl Float:vVel[3];
		GetEntPropVector(client, Prop_Data, "m_vecVelocity", vVel);
		vVel[2] = g_flBoost;
		TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vVel);
	}
}

public convar_ChangeBoost(Handle:convar, const String:oldVal[], const String:newVal[])
{
	g_flBoost = StringToFloat(newVal);
}

public convar_ChangeEnable(Handle:convar, const String:oldVal[], const String:newVal[])
{
	if (StringToInt(newVal) >= 1)
	{
		g_bDoubleJump = true;
	}
	else
	{
		g_bDoubleJump = false;
	}
}

public convar_ChangeMax(Handle:convar, const String:oldVal[], const String:newVal[])
{
	g_iJumpMax = StringToInt(newVal);
}

public Action:ShowGGHelp(client, args)
{
	new String:URLtoWebsite[256];
	GetConVarString(g_ShowGGHelp, URLtoWebsite, sizeof(URLtoWebsite));
	ShowMOTDPanel(client, "GunGame Help Page", URLtoWebsite, MOTDPANEL_TYPE_URL);
}

public Action:ShowGGtop10(client, args)
{
	if (GetConVarFloat(g_database_winner) == 1)
	{
		new String:URLtotopsite[256];
		GetConVarString(g_database_website, URLtotopsite, sizeof(URLtotopsite));
		ShowMOTDPanel(client, "GunGame Help Page", URLtotopsite, MOTDPANEL_TYPE_URL);
	}
}

public Action:Play_Win_Sound()
{
	if(GetConVarInt(g_gungame_winjoinsound) == 2 || 3)
	{
		new soundnumber = GetRandomInt(0,GetArraySize(soundfileswin)-1);
		decl String:filetoplay[PLATFORM_MAX_PATH+1];
		GetArrayString(soundfileswin, soundnumber, filetoplay, sizeof(filetoplay));
		decl String:buffer[PLATFORM_MAX_PATH+1];
		Format(buffer, sizeof(buffer), "play %s", (filetoplay), SNDLEVEL_GUNFIRE);
		for(new i = 1; i <= GetMaxClients(); i++)
		if(IsClientConnected(i) && !IsFakeClient(i) && IsClientInGame(i))
		{
			ClientCommand((i), buffer);
		}
	}
}

public IsValidClient(client)
{
   if ( !( 1 <= client <= MaxClients ) || !IsClientInGame(client) )
        return false;

   return true;
}