LoadConfig()
{
	decl String:sPath[PLATFORM_MAX_PATH];
	new Handle:hConfig          = CreateKeyValues("GunGame");
	BuildPath(Path_SM, sPath, sizeof(sPath), "configs/gungame_sound.txt");
	if (FileExists(sPath))
	{
		FileToKeyValues(hConfig, sPath);
		KvRewind(hConfig);
		KvJumpToKey(hConfig, "Sounds");
		KvGetString(hConfig, "LevelUp",    g_sSoundLevelUp,    PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelDown",  g_sSoundLevelDown,  PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelSteal", g_sSoundLevelSteal, PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelLast", g_sSoundLevelLast,   PLATFORM_MAX_PATH);
		KvGetString(hConfig, "vote",        g_sSoundvote,      PLATFORM_MAX_PATH);
		KvGetString(hConfig, "hunteryou",        g_sSoundHunterYou,      PLATFORM_MAX_PATH);
		KvGetString(hConfig, "hunterhere",        g_sSoundHunterHere,      PLATFORM_MAX_PATH);
		KvGetString(hConfig, "termyou",        g_sSoundTermYou,      PLATFORM_MAX_PATH);
		KvGetString(hConfig, "termhere",        g_sSoundTermHere,      PLATFORM_MAX_PATH);

		if (!StrEqual(g_sSoundLevelUp,    ""))
		{
			LoadSound(g_sSoundLevelUp);
		}
		if (!StrEqual(g_sSoundLevelDown,  ""))
		{
			LoadSound(g_sSoundLevelDown);
		}
		if (!StrEqual(g_sSoundLevelSteal, ""))
		{
			LoadSound(g_sSoundLevelSteal);
		}
		if (!StrEqual(g_sSoundLevelLast, ""))
		{
			LoadSound(g_sSoundLevelLast);
		}
		if (!StrEqual(g_sSoundvote,        ""))
		{
			LoadSound(g_sSoundvote);
		}
		if (!StrEqual(g_sSoundHunterYou,        ""))
		{
			LoadSound(g_sSoundHunterYou);
		}
		if (!StrEqual(g_sSoundHunterHere,        ""))
		{
			LoadSound(g_sSoundHunterHere);
		}
		if (!StrEqual(g_sSoundTermYou,        ""))
		{
			LoadSound(g_sSoundTermYou);
		}
		if (!StrEqual(g_sSoundTermHere,        ""))
		{
			LoadSound(g_sSoundTermHere);
		}
	}
	else
	{
		SetFailState("File Not Found: %s", sPath);
	}
	CloseHandle(hConfig);
}

LoadConfig2()
{
	decl String:sLevel[4], String:sPath[PLATFORM_MAX_PATH], String:sWeapon[16],
			 String:sWeapons[22][16] = {"colt", "p38", "c96", "garand", "k98", "k98_scoped", "m1carbine", "spring", "thompson", "mp40", "mp44", "bar", "30cal", "mg42", "bazooka", "pschreck", "frag_us", "frag_ger", "smoke_us", "smoke_ger", "riflegren_us", "riflegren_ger"};

	new  iLevel = 1,
	iOffsets[22] = { 4, 8, 12, 16, 20, 20, 24, 28, 32, 32, 32, 36, 40, 44, 48, 48, 52, 56, 68, 72, 84, 88},
	Handle:hConfig          = CreateKeyValues("GunGame");
	if (GetConVarInt(g_gungame_custom_on) == 0)
	{
		BuildPath(Path_SM, sPath, sizeof(sPath), "configs/gungame.txt");
	}
	if (GetConVarInt(g_gungame_custom_on) == 1)
	{
		BuildPath(Path_SM, sPath, sizeof(sPath), "configs/gungame_spade.txt");
	}
	if (GetConVarInt(g_gungame_custom_on) == 2)
	{
		BuildPath(Path_SM, sPath, sizeof(sPath), "configs/gungame_custom.txt");
	}
	if (FileExists(sPath))
	{
		for (new i = 0; i < sizeof(g_sWeapon); i++)
		{
			g_iAmmo[i]   = g_iOffset;
			g_sWeapon[i] = "";
		}
		FileToKeyValues(hConfig, sPath);
		KvJumpToKey(hConfig, "Levels");
		KvGetString(hConfig, "1", sWeapon, sizeof(sWeapon));
		while (!StrEqual(sWeapon, ""))
		{
			g_sWeapon[iLevel] = sWeapon;

			IntToString(++iLevel, sLevel, sizeof(sLevel));
			KvGetString(hConfig,  sLevel, sWeapon, sizeof(sWeapon));
		}
		KvRewind(hConfig);
		g_iLevels  = --iLevel;
		for (new i = 1, j; i <= g_iLevels; i++)
		{
			for (j   = 0; j < sizeof(sWeapons); j++)
			{
				if (StrEqual(g_sWeapon[i], sWeapons[j]))
				{
					g_iAmmo[i] += iOffsets[j];
					break;
				}
			}
		}
	}
	else
	{
		SetFailState("File Not Found: %s", sPath);
	}
	CloseHandle(hConfig);
}

LoadSound(const String:sFile[])
{
	decl String:sPath[PLATFORM_MAX_PATH];
	Format(sPath, sizeof(sPath), "sound/%s", sFile);
	PrecacheSound(sFile, true);
	AddFileToDownloadsTable(sPath);
	// OVERLAY
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile[i]);
		if(!IsModelPrecached(ggOverlayFile[i]))
		{
			PrecacheModel(ggOverlayFile[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_lost[i]);
		if(!IsModelPrecached(ggOverlayFile_lost[i]))
		{
			PrecacheModel(ggOverlayFile_lost[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_lostteamkill[i]);
		if(!IsModelPrecached(ggOverlayFile_lostteamkill[i]))
		{
			PrecacheModel(ggOverlayFile_lostteamkill[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_lostteamkillspade[i]);
		if(!IsModelPrecached(ggOverlayFile_lostteamkillspade[i]))
		{
			PrecacheModel(ggOverlayFile_lostteamkillspade[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_lostsuicide[i]);
		if(!IsModelPrecached(ggOverlayFile_lostsuicide[i]))
		{
			PrecacheModel(ggOverlayFile_lostsuicide[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_teamkill_spade[i]);
		if(!IsModelPrecached(ggOverlayFile_teamkill_spade[i]))
		{
			PrecacheModel(ggOverlayFile_teamkill_spade[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_LevelUp[i]);
		if(!IsModelPrecached(ggOverlayFile_LevelUp[i]))
		{
			PrecacheModel(ggOverlayFile_LevelUp[i], true);
		}
	}
	for(new i = 0; i < 2; i++)
	{
		AddFileToDownloadsTable(ggOverlayFile_LevelSteal[i]);
		if(!IsModelPrecached(ggOverlayFile_LevelSteal[i]))
		{
			PrecacheModel(ggOverlayFile_LevelSteal[i], true);
		}
	}
	// SUPERMAN
	AddFileToDownloadsTable("models/player/baronettes/superman.dx80.vtx");
	AddFileToDownloadsTable("models/player/baronettes/superman.dx90.vtx");
	AddFileToDownloadsTable("models/player/baronettes/superman.mdl");
	AddFileToDownloadsTable("models/player/baronettes/superman.phy");
	AddFileToDownloadsTable("models/player/baronettes/superman.sw.vtx");
	AddFileToDownloadsTable("models/player/baronettes/superman.vvd");
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit.vmt");
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit.vtf");
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit_n.vtf");
	PrecacheModel(SUPERMAN_MDL , true);

	// HUNTER
	AddFileToDownloadsTable("models/player/monster/hunter/hunter.dx80.vtx");
	AddFileToDownloadsTable("models/player/monster/hunter/hunter.dx90.vtx");
	AddFileToDownloadsTable("models/player/monster/hunter/hunter.mdl");
	AddFileToDownloadsTable("models/player/monster/hunter/hunter.phy");
	AddFileToDownloadsTable("models/player/monster/hunter/hunter.sw.vtx");
	AddFileToDownloadsTable("models/player/monster/hunter/hunter.vvd");
	AddFileToDownloadsTable("materials/models/player/monster/hunter/hunter.vmt");
	AddFileToDownloadsTable("materials/models/player/monster/hunter/hunter.vtf");
	AddFileToDownloadsTable("materials/models/player/monster/hunter/hunter_n.vtf");
	PrecacheModel(HUNTER_MDL , true);

	// TERMINATOR
	AddFileToDownloadsTable("models/player/monster/terminator/terminator.dx80.vtx");
	AddFileToDownloadsTable("models/player/monster/terminator/terminator.dx90.vtx");
	AddFileToDownloadsTable("models/player/monster/terminator/terminator.mdl");
	AddFileToDownloadsTable("models/player/monster/terminator/terminator.phy");
	AddFileToDownloadsTable("models/player/monster/terminator/terminator.sw.vtx");
	AddFileToDownloadsTable("models/player/monster/terminator/terminator.vvd");
	AddFileToDownloadsTable("materials/models/player/monster/terminator/tbody.vmt");
	AddFileToDownloadsTable("materials/models/player/monster/terminator/tbody.vtf");
	AddFileToDownloadsTable("materials/models/player/monster/terminator/tbody_n.vtf");
	AddFileToDownloadsTable("materials/models/player/monster/terminator/thead.vmt");
	AddFileToDownloadsTable("materials/models/player/monster/terminator/thead.vtf");
	AddFileToDownloadsTable("materials/models/player/monster/terminator/thead_n.vtf");
	PrecacheModel(TERMINATOR_MDL , true);
}